(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

open Parsetree;;

type cinfo = {
  ci_type_name : string;
  ci_arg_types : core_type list;
  ci_relations : relations;
  ci_location : Location.t;
};;

val find_cname : string -> cinfo;;

val find_tname : string -> type_declaration;;

val sigtype : (string * type_declaration) list -> unit;;

val pr_error : exn -> unit;;
