(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: complete.mli,v 1.4 2007/04/25 15:04:50 weis Exp $ *)

(** Some relations on a constructor imply relations on other
constructors, that the user cannot or does not need to
provide. [genr_fdefs] gives the list of function definitions
corresponding to a list of constructor definitions, after having added
all the required properties. It preserves the following properties:
- a relation does not appear twice,
- relations are sorted wrt predicate [compare_relation]. *)

val genr_fdefs :
  Spec.constructor_definition list -> Genr_base.function_definition list;;
