(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

val mktyp : Parsetree.core_type_desc -> Parsetree.core_type
val var_type : string -> Parsetree.core_type
val poly_type : string -> string list -> Parsetree.core_type
val const_type : string -> Parsetree.core_type
val bool_type : Parsetree.core_type
val arrow_type :
  Parsetree.core_type -> Parsetree.core_type -> Parsetree.core_type
val tuple_type : Parsetree.core_type list -> Parsetree.core_type
val list_type : Parsetree.core_type -> Parsetree.core_type
val eq_type : string -> string list -> Parsetree.core_type
val lidrel : Longident.t -> Longident.t -> bool
val ctrel : Parsetree.core_type -> Parsetree.core_type -> bool
type constr_declaration =
    string * Parsetree.core_type list * Parsetree.relations * Location.t
val cd_name : 'a * 'b * 'c * 'd -> 'a
val cd_arity : 'a * 'b list * 'c * 'd -> int
