(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

val fmt_longident : Buffer.t -> Longident.t -> unit
val constant : Buffer.t -> Asttypes.constant -> unit
val core_type : Buffer.t -> Parsetree.core_type -> unit
val x_core_types : Buffer.t -> Parsetree.core_type list -> unit
val pattern : Buffer.t -> Parsetree.pattern -> unit
val expression : Buffer.t -> Parsetree.expression -> unit
val value_description : Buffer.t -> Parsetree.value_description -> unit
val ptype_param : Buffer.t -> string -> unit
val ptype_params : Buffer.t -> string list -> unit
val side_spec : Buffer.t -> Parsetree.relation_side -> unit
val side : Buffer.t -> Parsetree.relation_side -> unit
val relation : Buffer.t -> Parsetree.relation -> unit
val relations : Buffer.t -> Parsetree.relation list -> unit
val constructor :
  Buffer.t ->
  string * Parsetree.core_type list * Parsetree.relation list * 'a -> unit
val constructors :
  Buffer.t ->
  (string * Parsetree.core_type list * Parsetree.relation list * 'a) list ->
  unit
val private_flag : Buffer.t -> Asttypes.private_flag -> unit
val mutable_flag : Buffer.t -> Asttypes.mutable_flag -> unit
val field :
  Buffer.t ->
  string * Asttypes.mutable_flag * Parsetree.core_type * 'a -> unit
val fields :
  Buffer.t ->
  (string * Asttypes.mutable_flag * Parsetree.core_type * 'a) list -> unit
val type_declaration :
  string -> Buffer.t -> Parsetree.type_declaration -> unit
val ptype_manifest : Buffer.t -> Parsetree.core_type option -> unit
val type_declarations :
  Buffer.t -> (string * Parsetree.type_declaration) list -> unit
val ptype_kind : Buffer.t -> Parsetree.type_kind -> unit
val pstr_type :
  Buffer.t -> (string * Parsetree.type_declaration) list -> unit
